Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Loading...
Reporting API is a collection of APIs Platforms use to get information about Liquid Collective Protocol Service Fees.
Alluvial's APIs can also interact with other third party services, such as those offered by third party custodians that Platforms may use to custody funds staked using Liquid Collective.
Please note that these guides are to support Platforms who are connecting with third party products that are not offered by or in partnership or affiliation with Alluvial. Products and services offered by third parties are subject to separate terms and conditions. Visit the website of the third parties noted in these guides for more information on their offerings.
Alluvial exposes several APIs to help developers interact with the Liquid Collective Protocol.
Using Alluvial APIs makes it easy to onboard and interact with the Liquid Collective protocol.
There are two types of Liquid Collective Platforms. Platforms either:
Enable mint/redeem: These Platforms enable direct Liquid Collective protocol interactions, including depositing ETH to Ethereum's deposit contract and redeeming LsETH for ETH (minting and redeeming). These Platforms offer KYC/AML and Sanctions Screening procedures for their users, then submit the user's wallet address to Liquid Collective's Allowlist smart contract upon successful completion.
Enable secondary interactions: These Platforms do not enable minting, redeeming, or direct Liquid Collective protocol interactions, but do enable secondary protocol interactions such as trading, lending, or other services not required to Allowlist KYC/AML and Sanctions Screened wallet addresses. Users of these Platforms can seamlessly interact with LsETH, and may accrue Ethereum's consensus and execution layer network rewards simply by holding LsETH.
There are two lists that Platforms can interact with:
Allowlist: Any address added to this list can mint and/or burn directly with the Liquid Collective protocol. Only wallets that have on-ramped via a mint/redeemed enabled Platform can be added to this list.
On-Platform: Platforms that only enable secondary interactions can only add wallets to the On-Platform list, and cannot interact with the Allowlist smart contract. When a wallet address is added to the Allowlist it is also automatically added to the On-Platform list. This list is used for calculating Platform rebates.
Below are two guides for Platforms to add their users to the appropriate lists.
Ethereum Data API is a collection of APIs that expose read data from the Ethereum network.
Review the Authentication Guide for the Alluvial API.
First create an account object for each of your users.
Request:
curl -X 'POST' \
Response:
{
"id": "da36a6fa-070d-4cd1-b99a-f2da4f4ccb20",
"key": "FO123",
"org_id": "org_WaYHN06ay6WoTjcz",
"status": "ACTIVE",
"created_at": "2023-03-17T17:24:18.031434748Z",
"wallets": []
}Attach a wallet object to each account. You can add the wallet to the Allowlist (on-chain) or the On-Platform list (off-chain).
The first example below shows how to add a wallet address to the Allowlist (which be default is added to the On-Platform list).
Request:
curl -X 'POST' \
'https://api.staging.alluvial.finance/v0/platform/accounts/da36a6fa-070d-4cd1-b99a-f2da4f4ccb20/wallets' \
-H 'accept: application/json' \
-H 'Authorization: Bearer eyJhbGci…CVm5g' \
-H 'Content-Type: application/json' \
-d '{
"address": "0x5210d328bC5651F92F4557EfDE08dd97A36A935c",
"type": "ETH"
}'Response:
{
"id": "a41c520e-fadd-4c0c-a1ce-d574ee731cee",
"type": "ETH",
"address": "0x5210d328bC5651F92F4557EfDE08dd97A36A935c",
"account_id": "993327a3-1d48-4eff-a9ee-7ec769ec1f64",
"status": "ALLOWLISTED",
"allowlisted": true,
"on_platform": true,
"created_at": "2024-03-25T18:38:31.427654433Z"
}Platforms that enable mint/redeem may also need to add a wallet address to the On-Platform list separately. The following request is for a Platform that enables mint/redeem to add a wallet to the On-Platform list.
Request:
Request:
Now that you have an Account object created and Wallet objects associated, the user can stake ETH and mint LsETH. Before depositing, ensure that the Wallet object(s) have a status = ALLOWLISTED.
To complete the staking process, review .
curl -X 'POST' \
'https://api.staging.alluvial.finance/v0/platform/accounts/da36a6fa-070d-4cd1-b99a-f2da4f4ccb20/wallets' \
-H 'accept: application/json' \
-H 'Authorization: Bearer eyJhbGci…CVm5g' \
-H 'Content-Type: application/json' \
-d '{
"address": "0x5210d328bC5651F92F4557EfDE08dd97A36A935c",
"type": "ETH",
"allowlisted": "false"
}'{
"address": "0x5210d328bC5651F92F4557EfDE08dd97A36A935c",
"created_at": "string",
"id": "string",
"status": "NOT_ALLOWLISTED",
"type": "ETH",
"on_platform": "true"
}Alluvial is a software development company supporting the development of the Liquid Collective protocol. We're focused on the overall growth and maturity of the ecosystem by fostering participation in proof of stake blockchains.
To learn more about the Liquid Collective protocol and how it works, check out Liquid Collective's documentation.
The Alluvial docs have three key sections:
Guides: This section contains several step by step guides for how technical teams can implement key Liquid Staking flows.
APIs: This section shows all the raw API requests that Liquid Collective Platforms can call.
: This section includes guides for how to interact with the Liquid Collective protocol via other software platforms.
If you are an engineer or technical person, looking to understand the level of effort or work involved in implementing the key flows (ETH staking and LsETH redemptions) then we recommend reviewing the and guides. The is a helpful compliment to these key guides.
Redemption API is a collection of APIs that expose read data on redemptions.
To see APIs used in an example implementation check out the Redemption guide (below).
Review the for the Alluvial API.
Platforms that enable secondary protocol interactions, such as trading, lending, or other services, can create an Account object. The Account object is generally associated with a Platform's customer.
Request:
Response:
After an Account object is created, associate a Wallet object to an account. You can associate one or many Wallet objects to a given Account object.
Request:
Response:
Your Platform is all set! Wallets added to the On-Platform list will be used to calculate the relevant Protocol Service Fee Rebates.
curl -X 'POST' \
'https://api.staging.alluvial.finance/v0/platform/accounts' \
-H 'accept: application/json' \
-H 'Authorization: Bearer 'eyJhbGci…CVm5g'
-d '{
"key": "foobar-123"
}'{
"id": "4b1d05ed-b498-4847-99a0-c415c6b19f6b",
"key": "foobar-123",
"org_id": "org_WaYHN06ay6WoT...",
"status": "ACTIVE",
"created_at": "2024-02-09T22:40:28.954304245Z",
"wallets": []
}curl -X 'POST' \
'https://api.staging.alluvial.finance/v0/platform/accounts/4b1d05ed-b498-4847-99a0-c415c6b19f6b/wallets/' \
-H 'accept: application/json' \
-H 'Authorization: Bearer 'eyJhbGci…CVm5g'
-D '{
"address": "0x469b998812B9675b7B2Fb37519f574fEA5ee92E8",
"allowlisted": "false",
"type": "ETH"
}'{
"id": "421a39a1-e9c3-4a33-81bc-98eff7bfd502",
"type": "ETH",
"address": "0x469b998812b9675b7b2fb37519f574fea5ee92e8",
"status": "NOT_ALLOWLISTED",
"on_platform": true,
"created_at": "2024-02-09T22:43:02.249045841Z"
}This guide is intended for Platforms to learn about how they can integrate the Liquid Collective protocol with the support of Alluvial's APIs.
To help illustrate how a Platform utilizes the Alluvial APIs to support its Liquid Collective protocol integration, this guide introduces a few fictional characters:
Acme Custodian Corp: Financial institution that is a Platform for the Liquid Collective protocol and will offer its customers the ability to participate in the Liquid Collective protocol by staking ETH.
Alice: user of Acme Custodian Corp
Bob: user of Acme Custodian Corp
A custodial wallet's private key(s) are held by either a 3rd party or by the financial institution that is servicing the wallet account on behalf of the customer. In this example, Alice and Bob have a custodial account with Acme Corp and Acme Corp owns / has access to the private key associated with Alice's and Bob's wallet addresses.
Below is an example of the flow of funds, showing how the staking action by Alice and Bob will flow through Acme's architecture and the Alluvial APIs.
Non-custodial (or self-managed) wallets are those in which the customer holds the private keys. In this example, Alice is the only one with access to the private key for her wallet.
The largest differences between the two flow of funds diagrams are the wallet ownership and actions (i.e. signing transactions).
A segregated account structure is one where each customer at the financial institution (ex. Acme Corp) has their own unique, separate account. In this example, both Alice and Bob have their own unique Ethereum address associated with their individual accounts at Acme Corp.
Based on the example segregated account structure, you can see how Acme Corp will map its internal accounts to the technical resources (Organization, Depositor, Wallet) created when interacting with the Alluvial API.
An omnibus account is an account structure in which all users' accounts are grouped into a single wallet address.
Below is an image of how to map Acme's architecture to resources (Organization, Depositor, and Wallet) created via Alluvial's API.
Alluvial isn't aware of, and at no time has control over, the underlying account structure Acme implements. Acme will create a Depositor object that represents all of the internal customers.
This guide walks users through how to use authenticate requests using the Alluvial APIs.
Below is a ladder diagram showing the flow to create an access token.
This flow involves 3 parties:
Platform Server: the client looking to access the Alluvial API and which has previously been given a Client ID and Client Secret credentials.
Alluvial Authorization Server: responsible for validating credentials and generating JWT Access Token.
Alluvial API: the target resource to be accessed.
To obtain an access token, use the a request below using your client id and secret.
Request:
Response:
Access Token should be reused for every request until it expires, in which case they should go through the Client Credential Flow again to obtain a fresh Access Token.
To use the access token, pass it via the HTTP header Authorization: Bearer
If you receive a 2xx response, you are now able to make fully authenticated requests.
If you receive a 4xx response, check if your access token is expired.
You are now ready to make requests! Please check out our guides on and .
Alluvial's changelog records changes made to the Alluvial API specification, including new features, improvements, bug fixes, and more.
Commercials V3 is live. New v1 reporting endpoints expose platform, originator, and operator fees and rates under the V3 fee model: /eth/v1/platforms/{date}, /eth/v1/originators/{date}, and /eth/v1/operators/{date}. See the Reporting API reference.
The v0 /eth/v0/platforms/{date} and /eth/v0/operators/{date} endpoints stop populating platform fees and rates from this date forward. They remain valid for historical data through 2026-04-30. Migrate to the v1 endpoints for any period on or after 2026-05-01.
Discounting APIs are live! These APIs enable adding a new target rate in the event Platforms need to adjust the net Protocol Service Fee rate for specific accounts and/or wallets.
Summary APIs are now exposed within the Reporting API. Summary APIs allow for teams to get data for a range of dates rather than a specific day.
Reporting API now exposes an endpoint for Platforms with segregated accounts to get rewards information. You can see examples in our .
Reporting API now exposes an endpoint for Platforms with an omnibus to get rewards information. You can see examples in our .
On-Platform list has been created to allow Platforms that only want to allow for a wallet to take part in secondary actions of LsETH to be accounted for. More information can be found in the guide or guide.
When creating a wallet, Platforms that allow for minting and redeeming, but only want to allow a wallet for secondary interactions can add these wallets to the on_platform list.
Introduction of . These replace the Depositor APIs that are now marked for .
Expose redemption requests by address via /eth/v0/redeems
Expose redemption requests by id via /eth/v0/redeems/{idx}
Expose redemption manager (heights) via /eth/v0/redeems_info
This API can be used with the .
Expose redeem projected redeemable at timestamp via /eth/v0/redeems/{idx}/projection
Expose manager projected fulfilled at timestamp via /eth/v0/redeems_info/projection
This API can be used with the .
Remove address from Allowlister via PATCH /v0/depositors/{idOrKey}/wallets/{idOrAddress}/remove
Rather than removing the entire Depositor object, Platforms can now remove only the wallet address. This is the recommended approach for most cases where an a Platform needs to revoke a wallet address' Allowlist permissions.
The wallet will is still able to transfer LsETH to other wallets.
curl 'https://auth.alluvial.finance/oauth/token' \
--header 'content-type: application/json' \
--data '{
"audience": "https://api.staging.alluvial.finance",
"grant_type": "client_credentials",
"client_id": "<YOUR_CLIENT_ID>",
"client_secret": "<YOUR_CLIENT_SECRET>"
}'{
"access_token": "eyJhbGci…CVm5g",
"scope": "read:eth-oracle read:eth-contracts read:eth-operators",
"expires_in": 86400,
"token_type": "Bearer"
}curl 'https://api.staging.alluvial.finance/v0/wallets/0x2B7ff5d4C14A9Da8d5C9354c7A52aB40DdC1C01e' \
--header 'Accept: application/json' \
--header 'Authorization: Bearer eyJh...b'






Checks whether a Solana wallet address is allowlisted for staking and redemption operations.
Endpoint: GET https://api.alluvial.finance/sol/v0/allowlist/{address}
Path Parameters:
address
string
Response:
Response Fields:
Adds a Solana wallet address to the allowlist, granting permissions for staking and/or redemption operations.
Endpoint: POST https://api.alluvial.finance/sol/v0/allowlist
Request Body:
Request Fields:
Response:
Response Fields:
Alluvial exposes several non-authenticated APIs to support DApps
Solana wallet address to check
{
"address": "7xKXtg2CW87d97TXJSDpbD5jBkheTqA83TZRuJosgAsU",
"allowlisted": true,
"permissions": {
"staking": true,
"redemption": true
}
}address
string
The Solana wallet address that was checked
allowlisted
boolean
Whether the wallet is on the allowlist
permissions.staking
boolean
Whether the wallet has permission to stake SOL
{
"address": "7xKXtg2CW87d97TXJSDpbD5jBkheTqA83TZRuJosgAsU",
"permissions": {
"staking": true,
"redemption": true
}
}address
string
Yes
Solana wallet address to add to the allowlist
permissions.staking
boolean
Yes
Grant permission to stake SOL
permissions.redemption
{
"address": "7xKXtg2CW87d97TXJSDpbD5jBkheTqA83TZRuJosgAsU",
"allowlisted": true,
"permissions": {
"staking": true,
"redemption": true
},
"created_at": "2025-01-15T10:30:00Z"
}address
string
The Solana wallet address that was added
allowlisted
boolean
Confirmation that the wallet is now on the allowlist
permissions.staking
boolean
Whether the wallet has permission to stake SOL
This page shows the process for creating an access token.
When onboarding with Alluvial, you will receive API credentials. These include a client_id and client_secret.
After receiving your credentials use the curl request below, updating the client_id and client_secret with your specific credentials.
Response
Request
Response
curl -X 'POST' \
'https://auth.staging.alluvial.finance/oauth/token' \
-H 'content-type: application/json' \
-d '{
"audience": "https://api.staging.alluvial.finance",
"grant_type": "client_credentials",
"client_id": "<YOUR_CLIENT_ID>",
"client_secret": "<YOUR_CLIENT_SECRET>"
}'{
"access_token": "eyJz93a...k4laUZw",
"scope": "read:eth-oracle...read:eth-operators",
"expires_in": 86400,
"token_type": "Bearer"
}curl -X 'POST' \
'https://auth.alluvial.finance/oauth/token' \
-H 'content-type: application/json' \
-d '{
"audience": "https://api.alluvial.finance",
"grant_type": "client_credentials",
"client_id": "<YOUR_CLIENT_ID>",
"client_secret": "<YOUR_CLIENT_SECRET>"
}'{
"access_token": "eyJz93a...k4laUWw",
"scope": "read:eth-oracle...read:eth-operators",
"expires_in": 86400,
"token_type": "Bearer"
}permissions.redemption
boolean
Whether the wallet has permission to redeem lsSOL
boolean
Yes
Grant permission to redeem lsSOL
permissions.redemption
boolean
Whether the wallet has permission to redeem lsSOL
created_at
string
ISO 8601 timestamp when the wallet was allowlisted
List latest available high-level protocol
Display LsETH values in units of wei or ether. If not present, LsETH is set by default.
OK
3.97124831.0123452023-01-02T03:04:05Z0.18510.153.375561055f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef0.111.234122007944.381120520123.456789763232Bad Request
error messageIR001Internal error
error messageIR001GET /eth/v1/protocol HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"a_srr_7d": "3.9712483",
"conversion_rate": "1.012345",
"date": "2023-01-02T03:04:05Z",
"gross_fee_lseth": "0.1851",
"gross_fee_rate": "0.15",
"net_srr_7d": "3.375561055",
"oracle_report": "f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef",
"protocol_service_fee_rate": "0.11",
"rewards_eth": "1.234",
"total_eth_staked": "122007944.381",
"total_lseth_supply": "120520123.456789",
"total_protocol_active_keys_count": 76,
"total_protocol_burns_lseth": "32",
"total_protocol_mints_lseth": "32"
}List high-level protocol info for a given date
Date filter by year, month or day (eg. 2023, 2023-12, 2023-12-31). Note: times are UTC
Display LsETH values in units of wei or ether. If not present, LsETH is set by default.
OK
3.97124831.0123452023-01-02T03:04:05Z0.18510.153.375561055f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef0.111.234122007944.381120520123.456789763232Bad Request
error messageIR001Internal error
error messageIR001GET /eth/v1/protocol/{date} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"a_srr_7d": "3.9712483",
"conversion_rate": "1.012345",
"date": "2023-01-02T03:04:05Z",
"gross_fee_lseth": "0.1851",
"gross_fee_rate": "0.15",
"net_srr_7d": "3.375561055",
"oracle_report": "f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef",
"protocol_service_fee_rate": "0.11",
"rewards_eth": "1.234",
"total_eth_staked": "122007944.381",
"total_lseth_supply": "120520123.456789",
"total_protocol_active_keys_count": 76,
"total_protocol_burns_lseth": "32",
"total_protocol_mints_lseth": "32"
}
]List wallet transactions for a given time period and wallet address
Wallet address
Start date (default: 1 year ago)
End date (default: current time)
Output as CSV
Page size (default: 100)
Next cursor
OK
109.50.962024-06-21true0x5E9E16C6DEB4022399E4FCD387BCB59AC5855762DepositOpaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX0Bad request
error messageIR001Not found
error messageIR001Internal error
error messageIR001GET /eth/v1/wallet/{address}/transactions HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"data": [
{
"amount_eth": 10,
"amount_lseth": 9.5,
"conversion_rate": 0.96,
"date": "2024-06-21",
"finalized": true,
"transaction_hash": "0x5E9E16C6DEB4022399E4FCD387BCB59AC5855762",
"transaction_type": "Deposit"
}
],
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
}
}List all platform fees for a given date
Date filter by year, month or day (eg. 2023, 2023-12, 2023-12-31). Note: times are UTC
Number of oracle reports per page (1-1000, default 100)
Cursor returned from previous page
OK
1.012345120520123.456789120520123.4567892023-01-02T03:04:05Zf071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000eforg_example12342024-01-31T23:59:59Z2572002024-01-01T00:00:00Z2500000.000012345670.00150.0001234567890.00350.0001234567890.00350.00012340.10.00001234567890.00350.00012345670.000123456732.12340.000123456732.12340.00012345670.00012345670.00012345670.00012345670.00012345670.00012345670.00012345670.00012345670.00012345670.00012345670.00012345670.0001234567120520123.4567890.00012345670.00012345670.00012345670.0970.00012345673Opaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX0Bad Request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /eth/v1/platforms/{date} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"data": [
{
"conversion_rate": 1.012345,
"cumulative_eth_supply": 120520123.456789,
"cumulative_lseth_supply": 120520123.456789,
"date": "2023-01-02T03:04:05Z",
"oracle_report": "f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef",
"org_id": "org_example1234",
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_lc_fees_lseth": 0.00001234567,
"period_lc_fees_rate": 0.0015,
"period_operator_fees_lseth": 0.000123456789,
"period_operator_fees_rate": 0.0035,
"period_originator_fees_lseth": 0.000123456789,
"period_originator_fees_rate": 0.0035,
"period_protocol_fee_lseth": 0.0001234,
"period_protocol_fee_rate": 0.1,
"period_tech_provider_fees_lseth": 0.0000123456789,
"period_tech_provider_fees_rate": 0.0035,
"platform": {
"off_platform_rebate": {
"adjusted_cumulative_platform_net_outflows_fees_lseth": 0.0001234567,
"adjusted_cumulative_platform_net_outflows_transfers_lseth": 0.0001234567,
"cumulative_platform_burns_lseth": 32.1234,
"cumulative_platform_fees_received_from_lc_lseth": 0.0001234567,
"cumulative_platform_mints_lseth": 32.1234,
"cumulative_platform_net_outflows_lseth": 0.0001234567,
"cumulative_platform_transfers_in_lseth": 0.0001234567,
"cumulative_platform_transfers_out_lseth": 0.0001234567,
"cumulative_protocol_on_platform_lseth": 0.0001234567,
"cumulative_protocol_outflows_lseth": 0.0001234567,
"period_off_platform_allocated_fees_lseth": 0.0001234567,
"period_off_platform_balance_lseth": 0.0001234567,
"period_off_platform_fees_lseth": 0.0001234567,
"period_platform_adjusted_net_outflows_lseth": 0.0001234567,
"period_platform_outflow_ratio": 0.0001234567,
"period_protocol_off_platform_gross_fee_lseth": 0.0001234567
},
"on_platform_rebate": {
"period_on_platform_allocated_fees_lseth": 0.0001234567,
"period_on_platform_balance_lseth": 120520123.456789,
"period_on_platform_fees_lseth": 0.0001234567,
"period_on_platform_ratio": 0.0001234567
},
"period_fees_lseth": 0.0001234567,
"period_fees_rate": 0.097,
"period_platform_balance_lseth": 0.0001234567
},
"version": 3
}
],
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
}
}List all originator fees for a given date
Date filter by year, month or day (eg. 2023, 2023-12, 2023-12-31). Note: times are UTC
Number of oracle reports per page (1-1000, default 100)
Cursor returned from previous page
OK
1.012345120520123.456789120520123.4567892023-01-02T03:04:05Zf071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000eforg_example12340.0001234567120520123.4567890.00012345670.00012345670.00012345670.0970.00012345670.00012345670.000123456732.12340.000123456732.12340.00012345670.00012345670.00012345670.00012345670.00012345670.00012345670.00012345672024-01-31T23:59:59Z2572002024-01-01T00:00:00Z2500000.00012340.13Opaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX0Bad Request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /eth/v1/originators/{date} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"data": [
{
"conversion_rate": 1.012345,
"cumulative_eth_supply": 120520123.456789,
"cumulative_lseth_supply": 120520123.456789,
"date": "2023-01-02T03:04:05Z",
"oracle_report": "f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef",
"org_id": "org_example1234",
"originator": {
"attributed_rebate": {
"period_originator_attributed_allocated_fees_lseth": 0.0001234567,
"period_originator_attributed_balance_lseth": 120520123.456789,
"period_originator_attributed_fees_lseth": 0.0001234567,
"period_originator_attributed_ratio": 0.0001234567
},
"period_fees_lseth": 0.0001234567,
"period_fees_rate": 0.097,
"period_originator_balance_lseth": 0.0001234567,
"unattributed_rebate": {
"adjusted_cumulative_originator_net_outflows_fees_lseth": 0.0001234567,
"cumulative_originator_attributed_lseth": 0.0001234567,
"cumulative_originator_burns_lseth": 32.1234,
"cumulative_originator_fees_received_from_lc_lseth": 0.0001234567,
"cumulative_originator_mints_lseth": 32.1234,
"cumulative_originator_net_outflows_lseth": 0.0001234567,
"cumulative_protocol_originator_outflows_lseth": 0.0001234567,
"period_originator_adjusted_total_net_outflows_lseth": 0.0001234567,
"period_originator_outflow_ratio": 0.0001234567,
"period_unattributed_allocated_fees_lseth": 0.0001234567,
"period_unattributed_balance_lseth": 0.0001234567,
"period_unattributed_fees_lseth": 0.0001234567
}
},
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_protocol_fee_lseth": 0.0001234,
"period_protocol_fee_rate": 0.1,
"version": 3
}
],
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
}
}List platform operator fees for a given date
Date filter by year, month or day (eg. 2023, 2023-12, 2023-12-31). Note: times are UTC
Number of oracle reports per page (1-1000, default 100)
Cursor returned from previous page
OK
1.0123452023-01-02T03:04:05Z50.510f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000eforg_example12342024-01-31T23:59:59Z2572002024-01-01T00:00:00Z2500000.000120.000063Opaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX0Bad Request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /eth/v1/operators/{date} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"data": [
{
"conversion_rate": 1.012345,
"date": "2023-01-02T03:04:05Z",
"end_operator_active_keys_count": 5,
"end_operator_active_keys_ratio": 0.5,
"end_protocol_active_keys_count": 10,
"oracle_report": "f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef",
"org_id": "org_example1234",
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_all_operators_fees_lseth": 0.00012,
"period_operator_fees_lseth": 0.00006,
"version": 3
}
],
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
}
}List rewards for a time period
Number of lots per page (default: 100, max: 1000)
Cursor for next page of lots
0.382748642252721461trueExample: false2024-01-312024-01-01OK
0.38274864225272152024-01-311.0372532256655270.000039305549364450.000039305549364450.0000380755743340172024-01-011.0371537463463845Opaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX02024-01-31T23:59:59Z2572002024-01-01T00:00:00Z2500000.00003930554936445Bad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001POST /eth/v1/rewards HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Content-Type: application/json
Accept: */*
Content-Length: 102
[
{
"balance_lseth": "0.382748642252721461",
"display_eth": false,
"end": "2024-01-31",
"start": "2024-01-01"
}
]{
"end_balance_lseth": "text",
"end_position_value_eth": "text",
"lots": [
{
"balance_lseth": 0.3827486422527215,
"end": "2024-01-31",
"end_conversion_rate": 1.037253225665527,
"end_position_value_eth": 0.00003930554936445,
"net_rewards_eth": 0.00003930554936445,
"net_rewards_lseth": 0.000038075574334017,
"principal_eth": 1,
"start": "2024-01-01",
"start_conversion_rate": 1.0371537463463845
}
],
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
},
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_net_rewards_eth": "text",
"period_net_rewards_lseth": "0.00003930554936445",
"position_apy": "text"
}List rewards by account for a specific date
["bb3e6114-af15-43a6-9b36-a5ec011d9d95"]2024-04-11falseOK
bb3e6114-af15-43a6-9b36-a5ec011d9d950.000039305549364450.38274864225272150.42354864225272150.000039305549364452024-04-112024-01-31T23:59:59Z2572002024-01-01T00:00:00Z250000ab3e5114-af15-45b8-9c43-a5ec011d9d950x30e2a735D692fC28CD31C28F1A8259b4790f9A230.005346333870.1090.0000062641748371040.0000004392973164280.491748642252721460.000039305549364450.0000062641748371040.0000062641748371040.0000053640514426790.0000069362734172580.0000001618463797392024-04-110.3827486422527214611.03725322566552768bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d00000164org_aDL0aCAXyWYgHQ4W2024-01-31T23:59:59Z2572002024-01-01T00:00:00Z2500000.10.0000062641748371040.0000004255505366740.4820886023517404210.0000380755743340170.0000062641748371040.0000062641748371040.000005196196026760.0000062641748371040.0000067192190001210.0000001567817766691.0371537463463845Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001POST /eth/v1/rewards/accounts HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Content-Type: application/json
Accept: */*
Content-Length: 106
{
"accounts": [
"bb3e6114-af15-43a6-9b36-a5ec011d9d95"
],
"day": "2024-04-11",
"include_breakdown_details": false
}[
{
"account_id": "bb3e6114-af15-43a6-9b36-a5ec011d9d95",
"account_totals": {
"cumulative_net_rewards_eth": 0.00003930554936445,
"end_balance_lseth": 0.3827486422527215,
"end_position_value_eth": 0.4235486422527215,
"period_net_rewards_eth": 0.00003930554936445
},
"day": "2024-04-11",
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"wallets": [
{
"account_id": "ab3e5114-af15-45b8-9c43-a5ec011d9d95",
"address": "0x30e2a735D692fC28CD31C28F1A8259b4790f9A23",
"avg_srr_hist": "0.00534633387",
"cumulative_burns_lseth": "0.109",
"cumulative_gross_rewards_eth": "0.000006264174837104",
"cumulative_lc_fees_eth": "0.000000439297316428",
"cumulative_mints_lseth": "0.49174864225272146",
"cumulative_net_rewards_eth": "0.00003930554936445",
"cumulative_operator_fees_eth": "0.000006264174837104",
"cumulative_originator_fees_eth": "0.000006264174837104",
"cumulative_platform_fees_eth": "0.000005364051442679",
"cumulative_protocol_fees_eth": "0.000006936273417258",
"cumulative_tech_provider_fees_eth": "0.000000161846379739",
"day": "2024-04-11",
"end_balance_lseth": "0.382748642252721461",
"end_conversion_rate": "1.037253225665527",
"oracle_report": "68bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d00000164",
"org_id": "org_aDL0aCAXyWYgHQ4W",
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_burns_lseth": "0.1",
"period_gross_rewards_eth": "0.000006264174837104",
"period_lc_fees_eth": "0.000000425550536674",
"period_mints_lseth": "0.482088602351740421",
"period_net_rewards_eth": "0.000038075574334017",
"period_operator_fees_eth": "0.000006264174837104",
"period_originator_fees_eth": "0.000006264174837104",
"period_platform_fees_eth": "0.00000519619602676",
"period_protocol_fee_rate": "0.000006264174837104",
"period_protocol_fees_eth": "0.000006719219000121",
"period_tech_provider_fees_eth": "0.000000156781776669",
"start_conversion_rate": "1.0371537463463845"
}
]
}
]List rewards by wallet for a specific date
["0x30e2a735D692fC28CD31C28F1A8259b4790f9A23"]2024-04-11falseOK
ab3e5114-af15-45b8-9c43-a5ec011d9d950x30e2a735D692fC28CD31C28F1A8259b4790f9A230.005346333870.1090.0000062641748371040.0000004392973164280.491748642252721460.000039305549364450.0000062641748371040.0000062641748371040.0000053640514426790.0000069362734172580.0000001618463797392024-04-110.3827486422527214611.03725322566552768bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d00000164org_aDL0aCAXyWYgHQ4W2024-01-31T23:59:59Z2572002024-01-01T00:00:00Z2500000.10.0000062641748371040.0000004255505366740.4820886023517404210.0000380755743340170.0000062641748371040.0000062641748371040.000005196196026760.0000062641748371040.0000067192190001210.0000001567817766691.0371537463463845Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001POST /eth/v1/rewards/wallets HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Content-Type: application/json
Accept: */*
Content-Length: 113
{
"addresses": [
"0x30e2a735D692fC28CD31C28F1A8259b4790f9A23"
],
"day": "2024-04-11",
"include_breakdown_details": false
}[
{
"account_id": "ab3e5114-af15-45b8-9c43-a5ec011d9d95",
"address": "0x30e2a735D692fC28CD31C28F1A8259b4790f9A23",
"avg_srr_hist": "0.00534633387",
"cumulative_burns_lseth": "0.109",
"cumulative_gross_rewards_eth": "0.000006264174837104",
"cumulative_lc_fees_eth": "0.000000439297316428",
"cumulative_mints_lseth": "0.49174864225272146",
"cumulative_net_rewards_eth": "0.00003930554936445",
"cumulative_operator_fees_eth": "0.000006264174837104",
"cumulative_originator_fees_eth": "0.000006264174837104",
"cumulative_platform_fees_eth": "0.000005364051442679",
"cumulative_protocol_fees_eth": "0.000006936273417258",
"cumulative_tech_provider_fees_eth": "0.000000161846379739",
"day": "2024-04-11",
"end_balance_lseth": "0.382748642252721461",
"end_conversion_rate": "1.037253225665527",
"oracle_report": "68bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d00000164",
"org_id": "org_aDL0aCAXyWYgHQ4W",
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_burns_lseth": "0.1",
"period_gross_rewards_eth": "0.000006264174837104",
"period_lc_fees_eth": "0.000000425550536674",
"period_mints_lseth": "0.482088602351740421",
"period_net_rewards_eth": "0.000038075574334017",
"period_operator_fees_eth": "0.000006264174837104",
"period_originator_fees_eth": "0.000006264174837104",
"period_platform_fees_eth": "0.00000519619602676",
"period_protocol_fee_rate": "0.000006264174837104",
"period_protocol_fees_eth": "0.000006719219000121",
"period_tech_provider_fees_eth": "0.000000156781776669",
"start_conversion_rate": "1.0371537463463845"
}
]Get reward summary for an account with new V4 parameter structure
Account ID or key
Start date (YYYY-MM-DD format, defaults to 1 month ago)
End date (YYYY-MM-DD format, defaults to current time)
Include daily breakdown details (default: false)
Number of daily reports per page (default: 100, max: 1000)
Cursor for next page of daily reports
OK
ab3e5114-af15-45b8-9c43-a5ec011d9d951.0454865181649966org_aDs4aCACyWYgMQ4A2024-01-31T23:59:59Z2572002024-01-01T00:00:00Z25000000.0000457471246737284.345976844e-70.000993767389853750.0000389598331894638.189616111e-77.868546e-100.0000052363758783620.0000067872914842651.601149364e-71.006282340620787ab3e5114-af15-45b8-9c43-a5ec011d9d950xF523F31Acf07Ff41D2616f9c1b73E762Ba8E56600xF523F31Acf07Ff41D2616f9c1b73E762Ba8E56600.000993767389853751.0062823406207872.22405e-130.0000062641748371047.868546e-104.45541235e-87.45441235e-81.2424021e-97.868546e-105.7150495e-90.0000062641748371048.28268039e-82.898938e-102024-04-0168bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d000001641.0371537463463845Opaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX0Bad request
error messageIR001Not found
error messageIR001Internal error
error messageIR001GET /eth/v1/rewards/accounts/{idOrKey}/summary HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"data": {
"account_id": "ab3e5114-af15-45b8-9c43-a5ec011d9d95",
"end_conversion_rate": 1.0454865181649966,
"org_id": "org_aDs4aCACyWYgMQ4A",
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_account_totals": {
"burns_lseth": 0,
"gross_rewards_eth": 0.000045747124673728,
"lc_fees_eth": 4.345976844e-7,
"mints_lseth": 0.00099376738985375,
"net_rewards_eth": 0.000038959833189463,
"operator_fees_eth": 8.189616111e-7,
"originator_fees_eth": 7.868546e-10,
"platform_fees_eth": 0.000005236375878362,
"protocol_fees_eth": 0.000006787291484265,
"tech_provider_fees_eth": 1.601149364e-7
},
"start_conversion_rate": 1.006282340620787,
"wallets": [
{
"account_id": "ab3e5114-af15-45b8-9c43-a5ec011d9d95",
"address": "0xF523F31Acf07Ff41D2616f9c1b73E762Ba8E5660",
"daily_reports": [
{
"address": "0xF523F31Acf07Ff41D2616f9c1b73E762Ba8E5660",
"balance_lseth": 0.00099376738985375,
"conversion_rate": 1.006282340620787,
"daily_burns_lseth": 2.22405e-13,
"daily_gross_rewards_eth": 0.000006264174837104,
"daily_lc_fees_eth": 7.868546e-10,
"daily_mints_lseth": 4.45541235e-8,
"daily_net_rewards_eth": 7.45441235e-8,
"daily_operator_fees_eth": 1.2424021e-9,
"daily_originator_fees_eth": 7.868546e-10,
"daily_platform_fees_eth": 5.7150495e-9,
"daily_protocol_fee_rate": 0.000006264174837104,
"daily_protocol_fees_eth": 8.28268039e-8,
"daily_tech_provider_fees_eth": 2.898938e-10,
"date": "2024-04-01",
"oracle_report": "68bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d00000164",
"previous_conversion_rate": 1.0371537463463845
}
]
}
]
},
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
}
}Get reward summary for a wallet address with new V4 parameter structure
Wallet ID or address (0x-prefixed hex)
Start date (YYYY-MM-DD format, defaults to 1 month ago)
End date (YYYY-MM-DD format, defaults to current time)
Include daily breakdown details (default: false)
Number of daily reports per page (default: 100, max: 1000)
Cursor for next page of daily reports
OK
ab3e5114-af15-45b8-9c43-a5ec011d9d950xF523F31Acf07Ff41D2616f9c1b73E762Ba8E56600xF523F31Acf07Ff41D2616f9c1b73E762Ba8E56600.000993767389853751.0062823406207872.22405e-130.0000062641748371047.868546e-104.45541235e-87.45441235e-81.2424021e-97.45441235e-85.7150495e-90.0000062641748371048.28268039e-82.898938e-102024-04-0168bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d000001641.03715374634638451.0454865181649966org_aDs4aCACyWYgMQ4A2024-01-31T23:59:59Z2572002024-01-01T00:00:00Z25000000.0000457471246737284.345976844e-70.000993767389853750.0000389598331894638.189616111e-77.868546e-100.0000052363758783620.0000067872914842651.601149364e-71.006282340620787Opaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX0Bad request
error messageIR001Not found
error messageIR001Internal error
error messageIR001GET /eth/v1/rewards/wallets/{idOrAddress}/summary HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"data": {
"account_id": "ab3e5114-af15-45b8-9c43-a5ec011d9d95",
"address": "0xF523F31Acf07Ff41D2616f9c1b73E762Ba8E5660",
"daily_reports": [
{
"address": "0xF523F31Acf07Ff41D2616f9c1b73E762Ba8E5660",
"balance_lseth": 0.00099376738985375,
"conversion_rate": 1.006282340620787,
"daily_burns_lseth": 2.22405e-13,
"daily_gross_rewards_eth": 0.000006264174837104,
"daily_lc_fees_eth": 7.868546e-10,
"daily_mints_lseth": 4.45541235e-8,
"daily_net_rewards_eth": 7.45441235e-8,
"daily_operator_fees_eth": 1.2424021e-9,
"daily_originator_fees_eth": 7.45441235e-8,
"daily_platform_fees_eth": 5.7150495e-9,
"daily_protocol_fee_rate": 0.000006264174837104,
"daily_protocol_fees_eth": 8.28268039e-8,
"daily_tech_provider_fees_eth": 2.898938e-10,
"date": "2024-04-01",
"oracle_report": "68bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d00000164",
"previous_conversion_rate": 1.0371537463463845
}
],
"end_conversion_rate": 1.0454865181649966,
"org_id": "org_aDs4aCACyWYgMQ4A",
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_wallet_totals": {
"burns_lseth": 0,
"gross_rewards_eth": 0.000045747124673728,
"lc_fees_eth": 4.345976844e-7,
"mints_lseth": 0.00099376738985375,
"net_rewards_eth": 0.000038959833189463,
"operator_fees_eth": 8.189616111e-7,
"originator_fees_eth": 7.868546e-10,
"platform_fees_eth": 0.000005236375878362,
"protocol_fees_eth": 0.000006787291484265,
"tech_provider_fees_eth": 1.601149364e-7
},
"start_conversion_rate": 1.006282340620787
},
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
}
}Get global information about protocol token supplies
OK
Count of total validators minus stopped validators on the consensus layer
58Total consensus ETH balance of all validators on the consensus layer (as reported by the Oracle) in Wei
128000000000000000000Height of the returned data
15034284Total collected rewards
3200000000000000000000ETH balance on the contract in Wei
5000000000000000000Number of deposits
2Total ETH balance of exited validators on the consensus layer (as reported by the Oracle) in Wei
128000000000000000000Total ETH balance of exiting validators on the consensus layer (as reported by the Oracle) in Wei
128000000000000000000Count of funded validators
102Previous typo made, keeping for backwards compatibility
102Count of funded validators and pending activation on the consensus layer (as reported by the Oracle)
2Total ETH balance of pending validators in GWei
64000000000000000000trueTotal ETH balance of skimmed withdrawals (as reported by the Oracle) in Wei
128000000000000000000falseCount of stopped LC validators on the consensus layer (as reported by the Oracle)
42Total ETH balance managed by the River protocol in GWei
3200000000000000000000Total ETH deposited
3200000000000000000000Total LsETH supply
3200000000000000000000Count of all LC validators found on the consensus layer (as reported by the Oracle)
100Internal error
error messageIR001GET /eth/v1/status HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"active_validator_count": 58,
"active_validators_eth_balance": "128000000000000000000",
"block_number": 15034284,
"collected_rewards": "3200000000000000000000",
"contract_eth_balance": "5000000000000000000",
"conversion_rate": 1,
"deposit_count": 2,
"exited_validators_eth_balance": "128000000000000000000",
"exiting_validators_eth_balance": "128000000000000000000",
"funded_validator_count": 102,
"funded_valitor_count": 102,
"pending_validator_count": 2,
"pending_validators_eth_balance": "64000000000000000000",
"rebalance_deposit_to_redeem_mode": true,
"skimmed_validators_eth_balance": "128000000000000000000",
"slashing_containment_mode": false,
"stopped_validator_count": 42,
"total_eth_balance": "3200000000000000000000",
"total_eth_deposited": "3200000000000000000000",
"total_supply": "3200000000000000000000",
"total_validator_count": 100
}Get global information about protocol token supplies at a given block number
Block height to query
OK
Count of total validators minus stopped validators on the consensus layer
58Total consensus ETH balance of all validators on the consensus layer (as reported by the Oracle) in Wei
128000000000000000000Height of the returned data
15034284Total collected rewards
3200000000000000000000ETH balance on the contract in Wei
5000000000000000000Number of deposits
2Total ETH balance of exited validators on the consensus layer (as reported by the Oracle) in Wei
128000000000000000000Total ETH balance of exiting validators on the consensus layer (as reported by the Oracle) in Wei
128000000000000000000Count of funded validators
102Previous typo made, keeping for backwards compatibility
102Count of funded validators and pending activation on the consensus layer (as reported by the Oracle)
2Total ETH balance of pending validators in GWei
64000000000000000000trueTotal ETH balance of skimmed withdrawals (as reported by the Oracle) in Wei
128000000000000000000falseCount of stopped LC validators on the consensus layer (as reported by the Oracle)
42Total ETH balance managed by the River protocol in GWei
3200000000000000000000Total ETH deposited
3200000000000000000000Total LsETH supply
3200000000000000000000Count of all LC validators found on the consensus layer (as reported by the Oracle)
100Bad Request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /eth/v1/status/{block_number} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"active_validator_count": 58,
"active_validators_eth_balance": "128000000000000000000",
"block_number": 15034284,
"collected_rewards": "3200000000000000000000",
"contract_eth_balance": "5000000000000000000",
"conversion_rate": 1,
"deposit_count": 2,
"exited_validators_eth_balance": "128000000000000000000",
"exiting_validators_eth_balance": "128000000000000000000",
"funded_validator_count": 102,
"funded_valitor_count": 102,
"pending_validator_count": 2,
"pending_validators_eth_balance": "64000000000000000000",
"rebalance_deposit_to_redeem_mode": true,
"skimmed_validators_eth_balance": "128000000000000000000",
"slashing_containment_mode": false,
"stopped_validator_count": 42,
"total_eth_balance": "3200000000000000000000",
"total_eth_deposited": "3200000000000000000000",
"total_supply": "3200000000000000000000",
"total_validator_count": 100
}List LsETH balance of several addresses It is possible to specify for which block and which addresses to get the balances.
Comma separated list of addresses (if empty returns all addresses)
Block number at which to get balance for (latest by default)
Limit of elements to return (100 by default)
OK
Owner address
0x123456789985ca04a69c35978c3a3e778d6ef172LsETH balance
4200000000000000000000Block height of the balance
15034284Bad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /eth/v1/balances HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"address": "0x123456789985ca04a69c35978c3a3e778d6ef172",
"balance": "4200000000000000000000",
"block_number": 15034284
}
]Get LsETH balance of a given address It is possible to specify for which block to get the balance at.
Account address to query the balance for
Block number at which to get balance for (latest by default)
OK
Owner address
0x123456789985ca04a69c35978c3a3e778d6ef172LsETH balance
4200000000000000000000Block height of the balance
15034284Bad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /eth/v1/balances/{address} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"address": "0x123456789985ca04a69c35978c3a3e778d6ef172",
"balance": "4200000000000000000000",
"block_number": 15034284
}Get the LsETH balance history for a given address It returns a balance object for every block a balance change occurred It is possible to filter the history for a range of blocks
Address of the balance to query balance for
Starting block height to query (0 by default)
Ending block height to query (latest by default)
Limit of elements to return (100 by default)
OK
Owner address
0x123456789985ca04a69c35978c3a3e778d6ef172LsETH balance
4200000000000000000000Block height of the balance
15034284Bad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /eth/v1/balances/{address}/history HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"address": "0x123456789985ca04a69c35978c3a3e778d6ef172",
"balance": "4200000000000000000000",
"block_number": 15034284
}
]List all the smart contracts addresses used
OK
Internal error
error messageIR001GET /eth/v1/contracts HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"allowlister": "text",
"deployment_block": 1,
"el_fee_recipient": "text",
"operators_registry": "text",
"oracle": "text",
"redeem_manager": "text",
"river": "text",
"withdraw": "text"
}List redeem requests filtered by owner addresses and/or specific redeem IDs.
At least one of owner or ids must be provided. When both are set the
filters are combined (AND): only redeems whose ID is in the list AND whose
owner is in the list are returned. IDs not found are silently omitted.
Owner address(es), comma-separated. Required if ids is not set.
Comma-separated list of redeem request IDs (max 500). Required if owner is not set.
Include claimable_amount_eth in response (default: true)
OK
The possible amount available to claim in ETH (only present when display_eth is true)
The possible amount available to claim in LsETH
The amount already claimed in ETH
The amount already claimed in LsETH
The height is the cumulative sum of all the sizes of preceding redeem requests
The ID of the redeem request
1048576The maximum amount of ETH redeemable by this request
The owner of the redeem request
Block time
Timestamp
The amount of the redeem request in LsETH
The withdrawal event ID needed to claim the redeem (or -1 when no withdrawals available)
42Bad Request
error messageIR001Internal Error
error messageIR001GET /eth/v1/redeems HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"claimable_amount_eth": "text",
"claimable_amount_lseth": "text",
"claimed_amount_eth": "text",
"claimed_amount_lseth": "text",
"height": "text",
"id": 1048576,
"max_redeemable_amount_eth": "text",
"owner": "text",
"requested_at": 1,
"status_claim": "NOT_CLAIMED",
"status_satisfaction": "PENDING_SATISFACTION",
"timestamp": "text",
"total_amount_lseth": "text",
"withdrawal_event_id": 42
}
]Get a redeem request by the request id. Optionally includes claimable ETH amount.
The redeem request id to query
Include claimable_amount_eth in response (default: true)
OK
The possible amount available to claim in ETH (only present when display_eth is true)
The possible amount available to claim in LsETH
The amount already claimed in ETH
The amount already claimed in LsETH
The height is the cumulative sum of all the sizes of preceding redeem requests
The ID of the redeem request
1048576The maximum amount of ETH redeemable by this request
The owner of the redeem request
Block time
Timestamp
The amount of the redeem request in LsETH
The withdrawal event ID needed to claim the redeem (or -1 when no withdrawals available)
42Bad Request
error messageIR001Not Found
error messageIR001Internal Error
error messageIR001GET /eth/v1/redeems/{idx} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"claimable_amount_eth": "text",
"claimable_amount_lseth": "text",
"claimed_amount_eth": "text",
"claimed_amount_lseth": "text",
"height": "text",
"id": 1048576,
"max_redeemable_amount_eth": "text",
"owner": "text",
"requested_at": 1,
"status_claim": "NOT_CLAIMED",
"status_satisfaction": "PENDING_SATISFACTION",
"timestamp": "text",
"total_amount_lseth": "text",
"withdrawal_event_id": 42
}Get a redeem request time projection for becoming redeemable. An upper bound modelled from the validator exit queue and withdrawal sweep, so delivery is expected on or before it. A request already covered by the withdrawal stack reports its real on-chain time instead. Returns 503 when no estimate is available, with a Retry-After when the condition is transient.
The redeem request id to query
OK
Bad Request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Not Found
error messageIR001Internal Error
error messageIR001Estimate unavailable; Retry-After is set only when retrying can help
error messageIR001GET /eth/v1/redeems/{idx}/projection HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"projected_redeemable_at": "text"
}Projects the current unbonding time: broadly how long a redemption submitted now would take. It is the later of two bounds - how long the validator exit and withdrawal-sweep pipeline takes right now, and when everything already queued ahead clears - so it is never faster than the backlog, nor faster than a validator can be exited and swept. It is a queue indicator rather than a delivery bound for a specific redemption: it does not vary with the amount being redeemed, so a large enough one can land after it. Returns 503 when no estimate is available, with a Retry-After when the condition is transient.
OK
Unauthorized
error messageIR001Forbidden
error messageIR001Internal Error
error messageIR001Estimate unavailable; Retry-After is set only when retrying can help
error messageIR001GET /eth/v1/redeems_info/projection HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"projected_fulfilled_at": "text"
}Returns validator exit queue info, including time estimates.
OK
Internal error
error messageIR001GET /eth/v1/validators/queue HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"exit_time_hours": "text",
"mandatory_exit_delay_hours": "text",
"sweep_time_hours": "text"
}Create a platform account with an ACTIVE status.
WARNING Integrators should make sure that the depositor has gone through an effective KYC/KYB process and is deemed within appetite to stake their ETH through the Liquid Collective.
When creating the depositor an integrator should supply a non-empty, unique identifying key (it can typically be an internal user identifier).
As long as a depositor remains in ACTIVE status, it is possible to attach wallets to it that will automatically be submitted to the protocol on-chain allowlist.
Unique identifier of the account (supplied by the client)
depositor_exampleAccount has been created
Time the account was created
2024-01-24T13:07:50.335845ZIdentifier of the account (generated server side)
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Unique key identifying the account (supplied by the client when creating the account)
depositor_exampleOrganization identifier the account belongs to
org_28CLGCvsdG7TlOHfStatus of the account (managed by the integrator)
ACTIVEBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001POST /v0/platform/accounts HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Content-Type: application/json
Accept: */*
Content-Length: 27
{
"key": "depositor_example"
}{
"created_at": "2024-01-24T13:07:50.335845Z",
"id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"key": "depositor_example",
"org_id": "org_28CLGCvsdG7TlOHf",
"status": "ACTIVE"
}List platform accounts
OK
Time the account was created
2024-01-24T13:07:50.335845ZIdentifier of the account (generated server side)
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Unique key identifying the account (supplied by the client when creating the account)
depositor_exampleOrganization identifier the account belongs to
org_28CLGCvsdG7TlOHfStatus of the account (managed by the integrator)
ACTIVE | PAUSED | REMOVED | DENIEDThe account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHUnauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /v0/platform/accounts HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"created_at": "2024-01-24T13:07:50.335845Z",
"id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"key": "depositor_example",
"org_id": "org_28CLGCvsdG7TlOHf",
"status": "ACTIVE | PAUSED | REMOVED | DENIED",
"wallets": [
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}
]
}
]Get platform account
Account ID or Key of the platform account
OK
Time the account was created
2024-01-24T13:07:50.335845ZIdentifier of the account (generated server side)
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Unique key identifying the account (supplied by the client when creating the account)
depositor_exampleOrganization identifier the account belongs to
org_28CLGCvsdG7TlOHfStatus of the account (managed by the integrator)
ACTIVE | PAUSED | REMOVED | DENIEDThe account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHUnauthorized
error messageIR001Forbidden
error messageIR001Not found
error messageIR001Internal error
error messageIR001GET /v0/platform/accounts/{idOrKey} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"created_at": "2024-01-24T13:07:50.335845Z",
"id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"key": "depositor_example",
"org_id": "org_28CLGCvsdG7TlOHf",
"status": "ACTIVE | PAUSED | REMOVED | DENIED",
"wallets": [
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}
]
}Set account's status to REMOVED.
Integrators can call this method for their inactive users to be removed from the liquid staking protocol(s) allowlist.
Once account's status has been set to REMOVED:
Removing a wallet from the protocol allowlist results in disabling the ability to stake or redeem ETH.
Note that removing a wallet from the allowlist is an asynchronous process that can take some time.
Account ID or Key of the account to remove
OK
Time the account was created
2024-01-24T13:07:50.335845ZIdentifier of the account (generated server side)
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Unique key identifying the account (supplied by the client when creating the account)
depositor_exampleOrganization identifier the account belongs to
org_28CLGCvsdG7TlOHfStatus of the account (managed by the integrator)
REMOVEDThe account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Not found
error messageIR001Internal error
error messageIR001PATCH /v0/platform/accounts/{idOrKey}/remove HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"created_at": "2024-01-24T13:07:50.335845Z",
"id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"key": "depositor_example",
"org_id": "org_28CLGCvsdG7TlOHf",
"status": "REMOVED",
"wallets": [
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}
]
}Set account's status to PAUSED.
Once an account's status has been set to PAUSED:
allowlisted wallet they will be unable to stake nor redeem.403. This is enforced synchronously at the API, in addition to the
allowlist removal the allowlister submits on-chain.Account ID or Key of the account to remove
OK
Time the account was created
2024-01-24T13:07:50.335845ZIdentifier of the account (generated server side)
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Unique key identifying the account (supplied by the client when creating the account)
depositor_exampleOrganization identifier the account belongs to
org_28CLGCvsdG7TlOHfStatus of the account (managed by the integrator)
PAUSEDThe account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Not found
error messageIR001Internal error
error messageIR001PATCH /v0/platform/accounts/{idOrKey}/pause HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"created_at": "2024-01-24T13:07:50.335845Z",
"id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"key": "depositor_example",
"org_id": "org_28CLGCvsdG7TlOHf",
"status": "PAUSED",
"wallets": [
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}
]
}Set a PAUSED account's status to ACTIVE.
This will enable the account to stake and redeem again (if the account has allowlisted wallets), and enable you to add more wallets to the account.
The transaction builders start crafting for the account's wallets again immediately; they read the account status per request, so there is no wait for the on-chain allowlist to catch up.
This is only possible for PAUSED accounts - DENIED or REMOVED accounts cannot be reactivated.
Account ID or Key of the account to reactivate
OK
Time the account was created
2024-01-24T13:07:50.335845ZIdentifier of the account (generated server side)
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Unique key identifying the account (supplied by the client when creating the account)
depositor_exampleOrganization identifier the account belongs to
org_28CLGCvsdG7TlOHfStatus of the account (managed by the integrator)
ACTIVEThe account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Not found
error messageIR001Internal error
error messageIR001PATCH /v0/platform/accounts/{idOrKey}/reactivate HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"created_at": "2024-01-24T13:07:50.335845Z",
"id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"key": "depositor_example",
"org_id": "org_28CLGCvsdG7TlOHf",
"status": "ACTIVE",
"wallets": [
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}
]
}Get platform wallet
Wallet ID or Address of the wallet (address in hex format prefixed with 0x)
OK
The account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Not found
error messageIR001Internal error
error messageIR001GET /v0/platform/wallets/{idOrAddress} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}List platform wallets
Enable to only return allowlisted wallets
Enable to only return wallets on_platform
Offset for pagination
Limit for pagination
OK
The account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /v0/platform/wallets HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}
]Create a wallet attached to an account
If the account is in ACTIVE status and if the wallet's has the allowlisted property set to true Alluvial will add the wallet address to the protocol on-chain allowlist.
Adding a wallet to the protocol allowlist results in enabling the wallet to proceed to deposit and redeem ETH on the protocol.
Note that submitting the wallet to the on-chain allowlist is an asynchronous process that can take some time. The onboarding allows to check the submission status by getting the wallet.
Important Notes:
allowlisted wallets if your organization is configured to do so.allowlist wallets, it method will do so by default.Account ID or Key of the account to add wallets to
Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Opt out of wallet being added to the OnPlatform list
trueThe type of wallet - chain or protocol it exists on
ETHOK
The account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001POST /v0/platform/accounts/{idOrKey}/wallets HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Content-Type: application/json
Accept: */*
Content-Length: 88
{
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"type": "ETH"
}{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}List all wallets for a platform account
Account ID or Key of the account
Enable to only return allowlisted wallets
Enable to only return wallets on_platform
Offset for pagination
Limit for pagination
OK
The account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Internal error
error messageIR001GET /v0/platform/accounts/{idOrKey}/wallets HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}
]Remove wallet from a given wallet from either the on_platform, the allowlisted, or both.
Account ID or Key of the account to remove wallet from
Wallet ID or Address of the wallet to be removed
Enable to remove wallet from the allowlist
Enable to remove wallet on_platform
OK
The account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Not found
error messageIR001Internal error
error messageIR001PATCH /v0/platform/accounts/{idOrKey}/wallets/{idOrAddress}/remove HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}Set wallet's status to PAUSED.
Once a wallet's status has been set to PAUSED:
allowlisted, it will be unable to stake nor redeem.The transaction builders refuse to craft for a paused wallet, on both Ethereum and
Solana, returning 403 — the wallet's owning account stays ACTIVE, so this is enforced
on the wallet's own status.
Depositor ID or Key of the depositor to pause wallet from
Wallet ID or Address of the wallet to be paused
Enable to pause wallet from the allowlist
Enable to pause wallet on_platform
OK
The account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Not found
error messageIR001Conflict
error messageIR001Internal error
error messageIR001PATCH /v0/platform/accounts/{idOrKey}/wallets/{idOrAddress}/pause HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}Set a PAUSED wallet's status to ACTIVE.
This will enable the wallet to stake and redeem again.
This action can only be performed under these conditions:
PAUSED status - DENIED or REMOVED wallets cannot be reactivated.ACTIVE status.Depositor ID or Key of the depositor to reactivate wallet from
Wallet ID or Address of the wallet to be reactivated
Enable to reactivate wallet from the allowlist
Enable to reactivate wallet on_platform
OK
The account ID of the wallet
ac0d0cdf-92bc-4cbe-a180-a2efb2387d16Wallet address in hexadecimal format with 0x prefix
0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045Whether the wallet is allowlisted
trueTime the wallet was created
2024-01-25T13:07:50.335845ZOur UUID for this wallet
dd8eefc8-0cc4-4a27-adc0-e1ebebed598dWhether the wallet is on platform
trueOriginator of the wallet, value is an organization ID
org_ABCDEFThe type of wallet - chain or protocol it exists on
ETHBad request
error messageIR001Unauthorized
error messageIR001Forbidden
error messageIR001Not found
error messageIR001Conflict
error messageIR001Internal error
error messageIR001PATCH /v0/platform/accounts/{idOrKey}/wallets/{idOrAddress}/reactivate HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"account_id": "ac0d0cdf-92bc-4cbe-a180-a2efb2387d16",
"address": "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045",
"allowlisted": true,
"created_at": "2024-01-25T13:07:50.335845Z",
"id": "dd8eefc8-0cc4-4a27-adc0-e1ebebed598d",
"on_platform": true,
"originator_org_id": "org_ABCDEF",
"status": "ALLOWLISTED",
"type": "ETH"
}List latest available high-level protocol
Display LsETH values in units of wei or ether. If not present, LsETH is set by default.
OK
3.97124831.0123452023-01-02T03:04:05Z0.18510.153.375561055f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef0.111.234122007944.381120520123.456789763232Bad Request
error messageIR001Internal error
error messageIR001GET /eth/v1/protocol HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"a_srr_7d": "3.9712483",
"conversion_rate": "1.012345",
"date": "2023-01-02T03:04:05Z",
"gross_fee_lseth": "0.1851",
"gross_fee_rate": "0.15",
"net_srr_7d": "3.375561055",
"oracle_report": "f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef",
"protocol_service_fee_rate": "0.11",
"rewards_eth": "1.234",
"total_eth_staked": "122007944.381",
"total_lseth_supply": "120520123.456789",
"total_protocol_active_keys_count": 76,
"total_protocol_burns_lseth": "32",
"total_protocol_mints_lseth": "32"
}List high-level protocol info for a given date
Date filter by year, month or day (eg. 2023, 2023-12, 2023-12-31). Note: times are UTC
Display LsETH values in units of wei or ether. If not present, LsETH is set by default.
OK
3.97124831.0123452023-01-02T03:04:05Z0.18510.153.375561055f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef0.111.234122007944.381120520123.456789763232Bad Request
error messageIR001Internal error
error messageIR001GET /eth/v1/protocol/{date} HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"a_srr_7d": "3.9712483",
"conversion_rate": "1.012345",
"date": "2023-01-02T03:04:05Z",
"gross_fee_lseth": "0.1851",
"gross_fee_rate": "0.15",
"net_srr_7d": "3.375561055",
"oracle_report": "f071c15d86fd9ae82f62bb4bb04963f14e04045bbcac8b5439984733207821bc000000ef",
"protocol_service_fee_rate": "0.11",
"rewards_eth": "1.234",
"total_eth_staked": "122007944.381",
"total_lseth_supply": "120520123.456789",
"total_protocol_active_keys_count": 76,
"total_protocol_burns_lseth": "32",
"total_protocol_mints_lseth": "32"
}
]Get reward details for a wallet address with new V4 parameter structure
Wallet address (0x-prefixed hex)
Start date (YYYY-MM-DD format)
End date (YYYY-MM-DD format, defaults to current time)
Display ETH fields (default: true)
Export to CSV
OK
0x30e2a735D692fC28CD31C28F1A8259b4790f9A230x30e2a735D692fC28CD31C28F1A8259b4790f9A230.005346333870.38274864225272151.0372532256655270.1090.0000069362734172580.491748642252721470.000039305549364450.10.0000067192190001210.482088602351740450.0000380755743340172024-04-1168bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d000001641.03715374634638451.04548651816499662024-01-31T23:59:59Z2572002024-01-01T00:00:00Z2500000.1090.0000069362734172580.491748642252721470.000039305549364451.006282340620787Opaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX0Bad request
error messageIR001Not found
error messageIR001Internal error
error messageIR001GET /eth/v1/wallet/{address}/rewards?start=text HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"data": {
"address": "0x30e2a735D692fC28CD31C28F1A8259b4790f9A23",
"daily_reports": [
{
"address": "0x30e2a735D692fC28CD31C28F1A8259b4790f9A23",
"avg_srr_hist": 0.00534633387,
"balance_lseth": 0.3827486422527215,
"conversion_rate": 1.037253225665527,
"cumulative_burns_lseth": 0.109,
"cumulative_fees_eth": 0.000006936273417258,
"cumulative_mints_lseth": 0.49174864225272147,
"cumulative_rewards_eth": 0.00003930554936445,
"daily_burns_lseth": 0.1,
"daily_fees_eth": 0.000006719219000121,
"daily_mints_lseth": 0.48208860235174045,
"daily_net_rewards_eth": 0.000038075574334017,
"date": "2024-04-11",
"oracle_report": "68bbc70ba87b9467831cc3ff56fc114f3659ba9e646042007d1d54f6b95f267d00000164",
"previous_conversion_rate": 1.0371537463463845
}
],
"end_conversion_rate": 1.0454865181649966,
"period": {
"end": "2024-01-31T23:59:59Z",
"end_epoch": 257200,
"start": "2024-01-01T00:00:00Z",
"start_epoch": 250000
},
"period_burns_lseth": 0.109,
"period_fees_eth": 0.000006936273417258,
"period_mints_lseth": 0.49174864225272147,
"period_rewards_eth": 0.00003930554936445,
"start_conversion_rate": 1.006282340620787
},
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
}
}Provides status information of the wallet (ex. ALLOWLISTED, SUBMITTED, etc...)
Wallet address
OK
trueALLOWLISTED| PAUSED | DENIEDBad request
error messageIR001Not found
error messageIR001Internal error
error messageIR001GET /eth/v1/wallet/{address}/status HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"allowlisted": true,
"status": "ALLOWLISTED| PAUSED | DENIED"
}List wallet transactions for a given time period and wallet address
Wallet address
Start date (default: 1 year ago)
End date (default: current time)
Output as CSV
Page size (default: 100)
Next cursor
OK
109.50.962024-06-21true0x5E9E16C6DEB4022399E4FCD387BCB59AC5855762DepositOpaque base64url-encoded pagination cursor. Pass as next_cursor on the next request to retrieve the next page. Absent when no further pages exist.
eyJpbmRleCI6MX0Bad request
error messageIR001Not found
error messageIR001Internal error
error messageIR001GET /eth/v1/wallet/{address}/transactions HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"data": [
{
"amount_eth": 10,
"amount_lseth": 9.5,
"conversion_rate": 0.96,
"date": "2024-06-21",
"finalized": true,
"transaction_hash": "0x5E9E16C6DEB4022399E4FCD387BCB59AC5855762",
"transaction_type": "Deposit"
}
],
"metadata": {
"next_cursor": "eyJpbmRleCI6MX0"
}
}List redeem requests filtered by owner addresses and/or specific redeem IDs.
At least one of owner or ids must be provided. When both are set the
filters are combined (AND): only redeems whose ID is in the list AND whose
owner is in the list are returned. IDs not found are silently omitted.
Owner address(es), comma-separated. Required if ids is not set.
Comma-separated list of redeem request IDs (max 500). Required if owner is not set.
Include claimable_amount_eth in response (default: true)
OK
The possible amount available to claim in ETH (only present when display_eth is true)
The possible amount available to claim in LsETH
The amount already claimed in ETH
The amount already claimed in LsETH
The height is the cumulative sum of all the sizes of preceding redeem requests
The ID of the redeem request
1048576The maximum amount of ETH redeemable by this request
The owner of the redeem request
Block time
Timestamp
The amount of the redeem request in LsETH
The withdrawal event ID needed to claim the redeem (or -1 when no withdrawals available)
42Bad Request
error messageIR001Internal Error
error messageIR001GET /eth/v1/redeems HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
[
{
"claimable_amount_eth": "text",
"claimable_amount_lseth": "text",
"claimed_amount_eth": "text",
"claimed_amount_lseth": "text",
"height": "text",
"id": 1048576,
"max_redeemable_amount_eth": "text",
"owner": "text",
"requested_at": 1,
"status_claim": "NOT_CLAIMED",
"status_satisfaction": "PENDING_SATISFACTION",
"timestamp": "text",
"total_amount_lseth": "text",
"withdrawal_event_id": 42
}
]Returns validator exit queue info, including time estimates.
OK
Internal error
error messageIR001GET /eth/v1/validators/queue HTTP/1.1
Host: api.alluvial.finance
Authorization: Bearer YOUR_SECRET_TOKEN
Accept: */*
{
"exit_time_hours": "text",
"mandatory_exit_delay_hours": "text",
"sweep_time_hours": "text"
}Alluvial's reporting API enables Platforms to request the ETH network rewards that their users have received. Below are two guides:
Platforms with omnibus account structure.
Platforms with segregated account structure.
Platforms that support an omnibus structure should use the /eth/v1/rewards endpoint. This will return data in a lots structure. Lots represent LsETH balance changes for a given period. Rewards can then be calculated for each period. Total rewards for a user is the sum of rewards for each lot.
Below is an example request where a Platform wants to see the rewards for a wallet. Assume that the user has a total balance of 3 but acquired at different dates.
The user had 1 LsETH from 2024-04-01 to 2024-04-10. As such this will be the first lot added to the request body.
The user then acquired 2 more LsETH, for a total of 3, as of 2024-04-11.
In our request below assume that the current date for which we want data is til 2024-04-15.
Platforms that support a segregated structure can use two different endpoints to get reward data at the account or wallet level.
Use the endpoint /eth/v1/rewards/accounts to display ETH network rewards at the account level.
Below is the response show the aggregated rewards for the account in addition for each address.
Use the endpoint /eth/v1/rewards/wallets to display ETH network rewards at the wallet level.
Below is the response showing the aggregated rewards for the account in addition for each address.
The Alluvial API provides a staking rewards rate (SRR), which is calculated as a 7 day trailing average.
To get SRR information, call the endpoint.
Based on providing a specific date of 2024-05-01, the returned SRR is 2.85%.
Platforms that want to provide a custom discount to their users can use the Discounting APIs to offload the calculations of a discounted net Protocol Service Fee to Alluvial's enterprise accounting service. Platforms can then use the API to call ETH network rewards, Protocol Service Fees, and end user discounts for one or more wallets or user accounts.
First, you will set a new target fee rate. This represents the new gross Protocol Service Fee rate that will be calculated for an account and/or wallet.
For example, the current gross rate is 10%. To offer a user an effective net rate of 8%, you'd set the target fee rate at 0.08, which effectively provides a 2% discount to the associated wallet(s) and/or account(s).
The target fee rate is now set at 8%.
On each Oracle report, you can use the Reporting APIs to see discounted values for the associated account, including the discounted net Protocol Service Fee, ETH network rewards received adjusted for that Fee, and effective end user discounts.
In the response below, you can see that the rebate_eth or rebate_lseth will reflect the amount the wallet is attributed to be reimbursed in order to achieve the the 8% target fee rate (or conversely, a 2% discount on the gross Protocol Service Fee).
The discount data is exposed via the following API endpoints:
/rewards/wallets
/eth/v0/rewards/accounts/:idOrKey/summary
/eth/v0/rewards/wallets/:idOrKey/summary
curl --request POST 'https://api.staging.alluvial.finance/eth/v1/rewards' \
--header 'Content-Type: application/json' \
--header 'Accept: application/json' \
--header 'Authorization: Bearer e...g' \
--data '[
{
"balance": "1",
"from": "2024-04-01",
"to": "2024-04-10"
},
{
"balance": "3",
"from": "2024-04-11",
"to": "2024-04-15"
}
]'{
"balance": "4",
"accrued_rewards": "0.0041516089956458",
"lots": [
{
"from": "2024-04-01",
"to": "2024-04-10",
"start_conversion_rate": "1.0014257204933798",
"end_conversion_rate": "1.0023467329617235",
"balance": "1",
"accrued_rewards": "0.0009210124683437"
},
{
"from": "2024-04-11",
"to": "2024-04-15",
"start_conversion_rate": "1.0026157619809285",
"end_conversion_rate": "1.0036926274900292",
"balance": "3",
"accrued_rewards": "0.0032305965273021"
}
]
}curl --request POST 'https://api.staging.alluvial.finance/eth/v1/rewards/accounts' \
--header 'Content-Type: application/json' \
--header 'Accept: application/json' \
--header 'Impersonate-Org: org_uLD0aCAXyWYg4WQH' \
--header 'Authorization: Bearer ey...Qg' \
--data '{
"accounts": [
"8f9d6eff-d630-4389-810f-89c4b07b8fc5"
],
"date": "2024-05-15"
}'[
{
"account_id": "8f9d6eff-d630-4389-810f-89c4b07b8fc5",
"totals": {
"balance_lseth": "0.0000198315414745",
"rewards_eth": "0.000000000092766089"
},
"date": "2024-05-15",
"wallets": [
{
"oracle_report": "1437a7330f02400a5662ed70f5c23b251d76fdb1ede48240d9f1e7bcd70540470000014b",
"address": "0x7fc2B172EcC8E4609088f341Aa0Fb3841De8A77A",
"account_id": "8f9d6eff-d630-4389-810f-89c4b07b8fc5",
"org_id": "org_WaYHN06ay6WoTjcz",
"date": "2024-05-15",
"balance_lseth": "0.00000991577073725",
"rewards_eth": "0.000000000092766089",
"total_rewards_eth": "0.000000000092766089",
"conversion_rate": "1.0085131998588114",
"previous_conversion_rate": "1.0085038444500037",
"mints_lseth": "0",
"total_mints_lseth": "0.00000991577073725",
"burns_lseth": "0",
"total_burns_lseth": "0",
"fees_eth": "0.000000000010307343",
"total_fees_eth": "0.000000000010307343",
"period_lc_fees_lseth": "0.000000000000979198",
"total_lc_fees_lseth": "0.000000000000979198",
"period_tech_provider_fees_lseth": "0.000000000000360757",
"total_tech_provider_fees_lseth": "0.000000000000360757",
"platform_fees_eth": "0.000000000007112067",
"total_platform_fees_eth": "0.000000000007112067",
"operator_fees_eth": "0.000000000001546101",
"total_operator_fees_eth": "0.000000000001546101"
}
]
}
]curl --request POST 'https://api.staging.alluvial.finance/eth/v1/rewards/wallets' \
--header 'Content-Type: application/json' \
--header 'Accept: application/json' \
--header 'Impersonate-Org: org_uLD0aCAXyWYg4WQH' \
--header 'Authorization: Bearer ey...Qg' \
--data '{
"addresses": [
"0x7fc2B172EcC8E4609088f341Aa0Fb3841De8A77A"
],
"date": "2024-05-15"
}'[
{
"oracle_report": "1437a7330f02400a5662ed70f5c23b251d76fdb1ede48240d9f1e7bcd70540470000014b",
"address": "0x7fc2B172EcC8E4609088f341Aa0Fb3841De8A77A",
"account_id": "8f9d6eff-d630-4389-810f-89c4b07b8fc5",
"org_id": "org_WaYHN06ay6WoTjcz",
"date": "2024-05-15",
"balance_lseth": "0.00000991577073725",
"rewards_eth": "0.000000000092766089",
"total_rewards_eth": "0.000000000092766089",
"conversion_rate": "1.0085131998588114",
"previous_conversion_rate": "1.0085038444500037",
"mints_lseth": "0",
"total_mints_lseth": "0.00000991577073725",
"burns_lseth": "0",
"total_burns_lseth": "0",
"fees_eth": "0.000000000010307343",
"total_fees_eth": "0.000000000010307343",
"period_lc_fees_lseth": "0.000000000000979198",
"total_lc_fees_lseth": "0.000000000000979198",
"period_tech_provider_fees_lseth": "0.000000000000360757",
"total_tech_provider_fees_lseth": "0.000000000000360757",
"platform_fees_eth": "0.000000000007112067",
"total_platform_fees_eth": "0.000000000007112067",
"operator_fees_eth": "0.000000000001546101",
"total_operator_fees_eth": "0.000000000001546101"
}
]curl 'https://api.alluvial.finance/eth/v0/protocol/2024-05-01' \
--header 'Accept: application/json' \
--header 'Accept: application/json'[
{
"oracle_report": "2e39c7e7e0b78c043ac98e190175fa7f057a75197647d4d844864ac06c98aa3400000225",
"date": "2024-05-01T12:14:47Z",
"total_protocol_mints_lseth": "89180.704128270784037675",
"total_protocol_burns_lseth": "6676.332903830493099868",
"total_protocol_active_keys_count": 2703,
"rewards_eth": "6.66289490787142415",
"gross_fee_rate": "0.1",
"gross_fee_lseth": "0.636483355669561459",
"conversion_rate": "1.0468294022963504",
"total_lseth_supply": "82674.954629966742503924",
"a_srr_7d": "2.85"
}
]curl --location --request POST 'https://api.staging.alluvial.finance/v0/platform/accounts/8f9d6eff-d630-4389-810f-89c4b07b8fc5/discount_rate' \
--header 'Content-Type: application/json' \
--header 'Accept: application/json' \
--header 'Authorization: Bearer eyJQ' \
--data '{
"target_fee_rate": 0.08
}'{
"account_id": "8f9d6eff-d630-4389-810f-89c4b07b8fc5",
"target_fee_rate": "0.08",
"created_at": "2024-06-24T21:27:07.387160077Z"
}curl --location --request POST 'https://api.staging.alluvial.finance/eth/v0/rewards/accounts' \
--header 'Content-Type: application/json' \
--header 'Accept: application/json' \
--header 'Authorization: Bearer eyJ...mQ' \
--data '{
"accounts": [
"8f9d6eff-d630-4389-810f-89c4b07b8fc5"
],
"date": "2024-06-22",
"unit": "lseth"
}'[
{
"account_id": "8f9d6eff-d630-4389-810f-89c4b07b8fc5",
"totals": {
"balance_lseth": "0.947997263286356641",
"rewards_eth": "0.001671038079957103"
},
"date": "2024-06-22",
"wallets": [
{
"oracle_report": "43306f4695a1d7ed4118c68fecd150e1f071b338815007960e61900d8d9c123e00000046",
"address": "0x4D1c3ec0B381F012A90f096cD4E8bc7746e4f2eB",
"account_id": "8f9d6eff-d630-4389-810f-89c4b07b8fc5",
"org_id": "org_WaYHN06ay6WoTjcz",
"date": "2024-06-22",
"balance_lseth": "0.00001",
"rewards_eth": "0.000000000087955639",
"total_rewards_eth": "0.000000020987954327",
"conversion_rate": "1.0106749980064223",
"previous_conversion_rate": "1.0106662024425232",
"mints_lseth": "0",
"total_mints_lseth": "0",
"burns_lseth": "0",
"total_burns_lseth": "0",
"fees_eth": "0.000000000009772849",
"total_fees_eth": "0.000000002331994927",
"dao_fees_eth": "0.000000000000928421",
"total_dao_fees_eth": "0.000000000221539524",
"provider_fees_eth": "0.00000000000034205",
"total_provider_fees_eth": "0.000000000081619819",
"slashing_fees_eth": "0.000000000000293185",
"total_slashing_fees_eth": "0.00000000006995985",
"platform_fees_eth": "0.000000000006743266",
"total_platform_fees_eth": "0.000000001609076496",
"platform_fees_at_discount_rate_eth": "0",
"total_platform_fees_at_discount_rate_eth": "0",
"operator_fees_eth": "0.000000000001465927",
"total_operator_fees_eth": "0.00000000034979924",
"gross_protocol_fee_rate": "0",
"discount_rate": "0",
"gross_fees_eth": "0.000000000009772849",
"total_gross_fees_eth": "0.000000002331994927",
"gross_rewards_eth": "0.000000000097728488",
"total_gross_rewards_eth": "0.000000000189971905",
"rebate_eth": "0",
"total_rebate_eth": "0",
"rebate_lseth": "0",
"total_rebate_lseth": "0"
},
{
"oracle_report": "43306f4695a1d7ed4118c68fecd150e1f071b338815007960e61900d8d9c123e00000046",
"address": "0x7fc2B172EcC8E4609088f341Aa0Fb3841De8A77A",
"account_id": "8f9d6eff-d630-4389-810f-89c4b07b8fc5",
"org_id": "org_WaYHN06ay6WoTjcz",
"date": "2024-06-22",
"balance_lseth": "0.947987263286356641",
"rewards_eth": "0.000008338082549768",
"total_rewards_eth": "0.001671017092002776",
"conversion_rate": "1.0106749980064223",
"previous_conversion_rate": "1.0106662024425232",
"mints_lseth": "0",
"total_mints_lseth": "5.947997863289656641",
"burns_lseth": "0",
"total_burns_lseth": "0.0000006000033",
"fees_eth": "0.000000926453616641",
"total_fees_eth": "0.000185668565778085",
"dao_fees_eth": "0.000000088013093581",
"total_dao_fees_eth": "0.000017638513748923",
"provider_fees_eth": "0.000000032425876582",
"total_provider_fees_eth": "0.000006498399802232",
"slashing_fees_eth": "0.000000027793608499",
"total_slashing_fees_eth": "0.000005570056973343",
"platform_fees_eth": "0.000000639252995482",
"total_platform_fees_eth": "0.000128111310386881",
"platform_fees_at_discount_rate_eth": "0",
"total_platform_fees_at_discount_rate_eth": "0",
"operator_fees_eth": "0.000000138968042496",
"total_operator_fees_eth": "0.000027850284866709",
"gross_protocol_fee_rate": "0",
"discount_rate": "0",
"gross_fees_eth": "0.000000926453616641",
"total_gross_fees_eth": "0.000185668565778085",
"gross_rewards_eth": "0.000009264536166409",
"total_gross_rewards_eth": "0.000018009094566287",
"rebate_eth": "0",
"total_rebate_eth": "0",
"rebate_lseth": "0",
"total_rebate_lseth": "0"
}
]
}
]Liquid Collective Platforms can use Fireblocks to custody digital assets.
Fireblocks is an easy-to-use platform to create new blockchain-based products and manage day-to-day digital asset operations. Fireblocks provides an MPC-based wallet allowing users to store their digital assets.
This guide will provide Platforms with a step-by-step process for using Fireblocks to interact with the Liquid Collective protocol.
Below is an example architecture for a Platform that uses Fireblocks as a custodian when the Platform's users stake ETH and/or redeem LsETH.
This implementation will take advantage of the Fireblocks SDK, specifically the Javascript SDK. Please follow the Fireblocks Javascript Guide to install the appropriate dependencies.
Create a new Javascript file, such as index.js.
Define dependencies at top of file.
const fs = require('fs');
const path = require('path');
const { FireblocksSDK } = require('fireblocks-sdk');
const { inspect } = require('util');Create or use an existing Fireblocks vault.
Response:
Next, put digital assets into the Fireblocks account.
Define the contract address for Goerli:
Call the supported digital assets in Fireblocks.
Response:
Add the LsETH to the newly created vault.
Request:
Response:
Now that you have an address associated with your Fireblocks account, you will create a Depositor object and add the wallet address to the Liquid Collective protocol Allowlist via the Alluvial API.
The steps for onboarding and adding to the Allowlist can be found in the . Come back to this guide once your wallet(s) have been successfully added to the Allowlist.
Now that you have successfully added your wallets to the Allowlist you can continue with staking.
In order to interact with the Liquid Collective protocol you will need to invoke Smart Contract functions.
This guide will use the Fireblocks Ethers.js provider, created by the Fireblocks team. To install read the .
In the index.js file add new dependencies
The Liquid Collective uses a TUPProxy architecture. Below are the details about the Proxy address and implementation contract.
Create a separate file called Contract.json.
In the file, add the ABI for the Liquid Collective protocol:
Goerli can be found
Mainnet can be found
Define the ABI address for Goerli.
Define the EIP-1193 Provider.
Create a function that calls the deposit function.
Request:
You've successfully staked ETH and should see LsETH returned in your Fireblocks vault.
Response:
Now you can implement the LsETH redemption flow, providing your users the ability to redeem their LsETH for ETH.
The next step is to allow the allowlisted wallets the ability to redeem their LsETH for ETH, thereby burning their LsETH.
There is a two-step process to receive the redeemed ETH. First, you will create a RedeemRequest that results in a redemption ID being returned. Once the redemption has been satisfied (full or partial) you can make a claimRedeemRequest call.
For more information check out .
The first function you will call is the .
Request:
A request redeem ID will be generated.
You can retrieve the request redeem ID either via the Alluvial API or by listening the the Redeem Manager contract events. More information can be found .
In order to get the Withdrawal Event ID, invoke the or call via the .
The example below will show invoking the resolveRedeemRequest function.
Request:
Response:
111
The resolveRedeemRequest function returns the status of the Withdrawal Event ID. More can be found .
You can proceed to make a claim now that you have both your redemption ID (53) and Withdrawal Event ID (111).
To make a claim request provide both the redemption request ID and the Withdrawal Event ID in an array.
Request:
After the claim is processed you will see the the deposit of ETH into your Fireblocks wallet.
To see the status of the claim you can either listen for events or use the Alluvial API. More information on the claiming process can be found .
Congratulations! You have now implemented the ETH staking and LsETH redemption flow using a Fireblocks account and SDK.
Appendix:
Below is the full code from the snippets above:
const createVault = async () => {
const name = 'LsETH blog';
const vaultAccount = await fireblocks.createVaultAccount(name);
console.log(inspect(vaultAccount, false, null, true));
};
createVault();{
"id": "6",
"name": "LsETH blog",
"hiddenOnUI": false,
"assets": [],
"autoFuel": false
}const CONTRACT_ADDRESS = process.env.CONTRACT_ADDRESS;
const getAssets = async() => {
const supportedAssets = await fireblocks.getSupportedAssets();
supportedAssets.forEach((asset, index, array) => {
if (asset.contractAddress == CONTRACT_ADDRESS) {
console.log(JSON.stringify(asset))
)
}
})
}
getAssets();{
"id": "LSETH_ETH_TEST3_4E2A",
"name": "Liquid Staked ETH",
"type": "ERC20",
"contractAddress": "0x3ecCAdA3e11c1Cc3e9B5a53176A67cc3ABDD3E46",
"nativeAsset": "ETH_TEST3",
"decimals": 18
}const addAssetToVault = async () => {
const vaultWallet = await fireblocks.createVaultAsset(
6,
'LSETH_ETH_TEST3_4E2A'
);
console.log(inspect(vaultWallet, false, null, true));
};
addAssetToVault();{
"id": "6",
"address": "<FIREBLOCKS ADDRESS>",
"legacyAddress": "",
"tag": ""
}const {
FireblocksWeb3Provider,
ChainId,
} = require('@fireblocks/fireblocks-web3-provider');
const ethers = require('ethers');Goerli
0x3ecCAdA3e11c1Cc3e9B5a53176A67cc3ABDD3E46
0xF32fC26C9604a380c311e7eC0c5E545917e7934f
Mainnet
0x8c1BEd5b9a0928467c9B1341Da1D7BD5e10b6549
0x48D93d8C45Fb25125F13cdd40529BbeaA97A6565
{
[...]
